#addaverage.py
import json,numpy as np,matplotlib.pyplot as plt

samples = np.fromfile("vep_online.dat",dtype=np.float32)
print("Shape of samples:",samples.shape)

with open("vep_stimuli.json","rt") as f:
    stiPoses = json.load(f)
print("stimuli positions:",stiPoses[:6])

signal = np.zeros(600)         #创建0值数组用于保存结果信号
plt.figure(figsize=(10,5))     #创建10英寸宽，5英寸高的图
ax = plt.subplot(121)          #在图中的左侧创建子图
ax.set_title("Raw VEP Signal") #左子图标题为"原始VEP信号"
for p in stiPoses:             #遍历全部刺激位置下标
    t = samples[p:p+600]       #从刺激位置开始切片600个样本
    signal += t                #累加样本片段至结果数组
    ax.plot(t)                 #在左子图绘出样本片段
signal /= len(stiPoses)        #对累加的结果数组进行平均

ax = plt.subplot(122)          #在图中创建右子图
ax.plot(signal)                #在右子图中绘制结果VEP信号
ax.set_title("Add Adveraged VEP Signal") #右子图标题为"叠加平均后的VEP信号"
plt.subplots_adjust(0.05,0.05,0.95,0.95,hspace=0.1)
plt.show()

